diff -ruN vdr-1.5.0/libsi/descriptor.h vdr-1.5.1/libsi/descriptor.h
--- vdr-1.5.0/libsi/descriptor.h	2006-05-28 16:25:30.000000000 +0200
+++ vdr-1.5.1/libsi/descriptor.h	2007-02-03 12:45:58.000000000 +0100
@@ -6,7 +6,7 @@
  *   the Free Software Foundation; either version 2 of the License, or     *
  *   (at your option) any later version.                                   *
  *                                                                         *
- *   $Id: descriptor.h 1.15 2006/05/28 14:25:30 kls Exp $
+ *   $Id: descriptor.h 1.16 2007/02/03 11:45:58 kls Exp $
  *                                                                         *
  ***************************************************************************/
 
@@ -210,7 +210,9 @@
    int getOrbitalPosition() const;
    int getWestEastFlag() const;
    int getPolarization() const;
-   int getModulation() const;
+   int getModulationSystem() const;
+   int getModulationType() const;
+   int getRollOff() const;
    int getSymbolRate() const;
    int getFecInner() const;
 protected:
@@ -236,6 +238,9 @@
 public:
    int getFrequency() const;
    int getBandwidth() const;
+   int getPriority() const;
+   int getTimeSlicingIndicator() const;
+   int getMpeFecIndicator() const;
    int getConstellation() const;
    int getHierarchy() const;
    int getCodeRateHP() const;
@@ -484,6 +489,30 @@
    const descr_ancillary_data *s;
 };
 
+class S2SatelliteDeliverySystemDescriptor : public Descriptor {
+public:
+   int getScramblingSequenceSelector() const;
+   int getMultipleInputStreamFlag() const;
+   int getBackwardsCompatibilityIndicator() const;
+   int getScramblingSequenceIndex() const;
+   int getInputStreamIdentifier() const { return input_stream_identifier; }
+protected:
+   virtual void Parse();
+private:
+   const descr_s2_satellite_delivery_system *s;
+   const descr_scrambling_sequence_selector *sss;
+   int input_stream_identifier;
+};
+
+class ExtensionDescriptor : public Descriptor {
+public:
+   int getExtensionDescriptorTag() const;
+protected:
+   virtual void Parse();
+private:
+   const descr_extension *s;
+};
+
 // Private DVB Descriptor  Premiere.de
 // 0xF2  Content Transmission Descriptor
 // http://dvbsnoop.sourceforge.net/examples/example-private-section.html
diff -ruN vdr-1.5.0/libsi/headers.h vdr-1.5.1/libsi/headers.h
--- vdr-1.5.0/libsi/headers.h	2006-09-02 22:25:16.000000000 +0200
+++ vdr-1.5.1/libsi/headers.h	2007-02-03 12:45:58.000000000 +0100
@@ -10,7 +10,7 @@
  *   the Free Software Foundation; either version 2 of the License, or     *
  *   (at your option) any later version.                                   *
  *                                                                         *
- *   $Id: headers.h 1.8 2006/09/02 20:25:16 kls Exp $
+ *   $Id: headers.h 1.9 2007/02/03 11:45:58 kls Exp $
  *                                                                         *
  ***************************************************************************/
 
@@ -942,9 +942,13 @@
 #if BYTE_ORDER == BIG_ENDIAN
    u_char west_east_flag                         :1;
    u_char polarization                           :2;
-   u_char modulation                             :5;
-#else
-   u_char modulation                             :5;
+   u_char roll_off                               :2;
+   u_char modulation_system                      :1;
+   u_char modulation_type                        :2;
+#else
+   u_char modulation_type                        :2;
+   u_char modulation_system                      :1;
+   u_char roll_off                               :2;
    u_char polarization                           :2;
    u_char west_east_flag                         :1;
 #endif
@@ -1349,9 +1353,15 @@
    u_char frequency_lo_lo                        :8;
 #if BYTE_ORDER == BIG_ENDIAN
    u_char bandwidth                              :3;
-   u_char reserved1                              :5;
-#else
-   u_char reserved1                              :5;
+   u_char priority                               :1;
+   u_char time_slicing_indicator                 :1;
+   u_char mpe_fec_indicator                      :1;
+   u_char reserved1                              :2;
+#else
+   u_char reserved1                              :2;
+   u_char mpe_fec_indicator                      :1;
+   u_char time_slicing_indicator                 :1;
+   u_char priority                               :1;
    u_char bandwidth                              :3;
 #endif
 #if BYTE_ORDER == BIG_ENDIAN
@@ -1492,10 +1502,10 @@
    /* TBD */
 };
 
-/* 0x65 ca_system_descriptor */
+/* 0x65 scrambling_descriptor */
 
-#define DESCR_CA_SYSTEM_LEN XX
-struct descr_ca_system {
+#define DESCR_SCRAMBLING_LEN XX
+struct descr_scrambling {
    u_char descriptor_tag                         :8;
    u_char descriptor_length                      :8;
    /* TBD */
@@ -1628,6 +1638,189 @@
    u_char descriptor_length                      :8;
 };
 
+/* 0x72 service_availbility_descriptor */
+
+struct descr_service_availbility {
+   u_char descriptor_tag                         :8;
+   u_char descriptor_length                      :8;
+#if BYTE_ORDER == BIG_ENDIAN
+   u_char availability_flag                      :1;
+   u_char reserved                               :7;
+#else
+   u_char reserved                               :7;
+   u_char availability_flag                      :1;
+#endif
+};
+
+/* 0x73 default_authority_descriptor (ETSI TS 102 323) */
+
+struct descr_default_authority {
+   u_char descriptor_tag                         :8;
+   u_char descriptor_length                      :8;
+};
+
+/* 0x74 related_content_descriptor (ETSI TS 102 323) */
+
+struct descr_related_content {
+   u_char descriptor_tag                         :8;
+   u_char descriptor_length                      :8;
+};
+
+/* 0x75 tva_id_descriptor (ETSI TS 102 323) */
+
+struct descr_tva_id {
+   u_char descriptor_tag                         :8;
+   u_char descriptor_length                      :8;
+};
+
+/* 0x76 content_identifier_descriptor (ETSI TS 102 323) */
+
+struct descr_content_identifier {
+   u_char descriptor_tag                         :8;
+   u_char descriptor_length                      :8;
+};
+
+/* 0x77 time_slice_fec_identifier_descriptor (ETSI EN 301 192) */
+
+struct descr_time_slice_fec_identifier {
+   u_char descriptor_tag                         :8;
+   u_char descriptor_length                      :8;
+#if BYTE_ORDER == BIG_ENDIAN
+   u_char time_slicing                           :1;
+   u_char mpe_fec                                :2;
+   u_char reserved                               :2;
+   u_char frame_size                             :3;
+#else
+   u_char frame_size                             :3;
+   u_char reserved                               :2;
+   u_char mpe_fec                                :2;
+   u_char time_slicing                           :1;
+#endif
+   u_char max_burst_duration                     :8;
+#if BYTE_ORDER == BIG_ENDIAN
+   u_char max_average_rate                       :4;
+   u_char time_slice_fec_id                      :4;
+#else
+   u_char time_slice_fec_id                      :4;
+   u_char max_average_rate                       :4;
+#endif
+};
+
+/* 0x78 ecm_repetition_rate_descriptor (ETSI EN 301 192) */
+
+struct descr_ecm_repetition_rate {
+   u_char descriptor_tag                         :8;
+   u_char descriptor_length                      :8;
+   u_char ca_system_id_hi                        :8;
+   u_char ca_system_id_lo                        :8;
+   u_char ecm_repetition_rate_hi                 :8;
+   u_char ecm_repetition_rate_lo                 :8;
+};
+
+/* 0x79 s2_satellite_delivery_system_descriptor */
+
+struct descr_s2_satellite_delivery_system {
+   u_char descriptor_tag                         :8;
+   u_char descriptor_length                      :8;
+#if BYTE_ORDER == BIG_ENDIAN
+   u_char scrambling_sequence_selector           :1;
+   u_char multiple_input_stream_flag             :1;
+   u_char backwards_compatibility_indicator      :1;
+   u_char reserved                               :5;
+#else
+   u_char reserved                               :5;
+   u_char backwards_compatibility_indicator      :1;
+   u_char multiple_input_stream_flag             :1;
+   u_char scrambling_sequence_selector           :1;
+#endif
+};
+
+struct descr_scrambling_sequence_selector {
+#if BYTE_ORDER == BIG_ENDIAN
+   u_char reserved                               :6;
+   u_char scrambling_sequence_index_hi_lo        :2;
+#else
+   u_char scrambling_sequence_index_hi_lo        :2;
+   u_char reserved                               :6;
+#endif
+   u_char scrambling_sequence_index_lo_hi        :8;
+   u_char scrambling_sequence_index_lo_lo        :8;
+};
+
+/* 0x7A enhanced_ac3_descriptor */
+
+struct descr_enhanced_ac3 {
+   u_char descriptor_tag                         :8;
+   u_char descriptor_length                      :8;
+#if BYTE_ORDER == BIG_ENDIAN
+   u_char component_type_flag                    :1;
+   u_char bsid_flag                              :1;
+   u_char mainid_flag                            :1;
+   u_char asvc_flag                              :1;
+   u_char mixinfoexists                          :1;
+   u_char substream1_flag                        :1;
+   u_char substream2_flag                        :1;
+   u_char substream3_flag                        :1;
+#else
+   u_char substream3_flag                        :1;
+   u_char substream2_flag                        :1;
+   u_char substream1_flag                        :1;
+   u_char mixinfoexists                          :1;
+   u_char asvc_flag                              :1;
+   u_char mainid_flag                            :1;
+   u_char bsid_flag                              :1;
+   u_char component_type_flag                    :1;
+#endif
+};
+
+/* 0x7B dts_descriptor */
+
+struct descr_dts {
+   u_char descriptor_tag                         :8;
+   u_char descriptor_length                      :8;
+#if BYTE_ORDER == BIG_ENDIAN
+   u_char sample_rate_code                       :4;
+   u_char bit_rate_code                          :6;
+   u_char nblks                                  :7;
+   u_char fsize_hi                               :6;
+   u_char fsize_lo                               :8;
+   u_char surround_mode                          :6;
+   u_char lfe_flag                               :1;
+   u_char extended_surround_flag                 :2;
+#else
+   u_char extended_surround_flag                 :2;
+   u_char lfe_flag                               :1;
+   u_char surround_mode                          :6;
+   u_char fsize_lo                               :8;
+   u_char fsize_hi                               :6;
+   u_char nblks                                  :7;
+   u_char bit_rate_code                          :6;
+   u_char sample_rate_code                       :4;
+#endif
+};
+
+/* 0x7C aac_descriptor */
+
+struct descr_aac {
+   u_char descriptor_tag                         :8;
+   u_char descriptor_length                      :8;
+   u_char profile_and_level                      :8;
+#if BYTE_ORDER == BIG_ENDIAN
+   u_char aac_type_flag                          :1;
+   u_char reserved                               :7;
+#else
+   u_char reserved                               :7;
+   u_char aac_type_flag                          :1;
+#endif
+};
+/* 0x7F extension_descriptor */
+
+struct descr_extension {
+   u_char descriptor_tag                         :8;
+   u_char descriptor_length                      :8;
+   u_char descriptor_tag_extension               :8;
+};
+
 /* MHP 0x00 application_descriptor */
 
 #define DESCR_APPLICATION_LEN 3
diff -ruN vdr-1.5.0/libsi/si.c vdr-1.5.1/libsi/si.c
--- vdr-1.5.0/libsi/si.c	2006-04-14 12:53:44.000000000 +0200
+++ vdr-1.5.1/libsi/si.c	2007-02-03 12:45:58.000000000 +0100
@@ -6,7 +6,7 @@
  *   the Free Software Foundation; either version 2 of the License, or     *
  *   (at your option) any later version.                                   *
  *                                                                         *
- *   $Id: si.c 1.16 2006/04/14 10:53:44 kls Exp $
+ *   $Id: si.c 1.17 2007/02/03 11:45:58 kls Exp $
  *                                                                         *
  ***************************************************************************/
 
@@ -425,6 +425,12 @@
          case AncillaryDataDescriptorTag:
             d=new AncillaryDataDescriptor();
             break;
+         case S2SatelliteDeliverySystemDescriptorTag:
+            d=new S2SatelliteDeliverySystemDescriptor();
+            break;
+         case ExtensionDescriptorTag:
+            d=new ExtensionDescriptor();
+            break;
 
          //note that it is no problem to implement one
          //of the unimplemented descriptors.
@@ -459,12 +465,23 @@
          case PartialTransportStreamDescriptorTag:
          case DataBroadcastDescriptorTag:
          case DataBroadcastIdDescriptorTag:
-         case CaSystemDescriptorTag:
+         case ScramblingDescriptorTag:
          case AC3DescriptorTag:
          case DSNGDescriptorTag:
          case AnnouncementSupportDescriptorTag:
          case AdaptationFieldDataDescriptorTag:
          case TransportStreamDescriptorTag:
+
+         //defined in ETSI EN 300 468 v 1.7.1
+         case DefaultAuthorityDescriptorTag:
+         case RelatedContentDescriptorTag:
+         case TVAIdDescriptorTag:
+         case ContentIdentifierDescriptorTag:
+         case TimeSliceFecIdentifierDescriptorTag:
+         case ECMRepetitionRateDescriptorTag:
+         case EnhancedAC3DescriptorTag:
+         case DTSDescriptorTag:
+         case AACDescriptorTag:
          default:
             if (!returnUnimplemetedDescriptor)
                return 0;
diff -ruN vdr-1.5.0/libsi/si.h vdr-1.5.1/libsi/si.h
--- vdr-1.5.0/libsi/si.h	2006-05-27 15:07:20.000000000 +0200
+++ vdr-1.5.1/libsi/si.h	2007-02-03 12:47:25.000000000 +0100
@@ -6,7 +6,7 @@
  *   the Free Software Foundation; either version 2 of the License, or     *
  *   (at your option) any later version.                                   *
  *                                                                         *
- *   $Id: si.h 1.15 2006/05/27 13:07:20 kls Exp $
+ *   $Id: si.h 1.16 2007/02/03 11:47:25 kls Exp $
  *                                                                         *
  ***************************************************************************/
 
@@ -108,7 +108,7 @@
                FrequencyListDescriptorTag = 0x62,
                PartialTransportStreamDescriptorTag = 0x63,
                DataBroadcastDescriptorTag = 0x64,
-               CaSystemDescriptorTag = 0x65,
+               ScramblingDescriptorTag = 0x65,
                DataBroadcastIdDescriptorTag = 0x66,
                TransportStreamDescriptorTag = 0x67,
                DSNGDescriptorTag = 0x68,
@@ -122,6 +122,19 @@
                AdaptationFieldDataDescriptorTag = 0x70,
                ServiceIdentifierDescriptorTag = 0x71,
                ServiceAvailabilityDescriptorTag = 0x72,
+  // defined by ETSI (EN 300 468) v 1.7.1
+               DefaultAuthorityDescriptorTag = 0x73,
+               RelatedContentDescriptorTag = 0x74,
+               TVAIdDescriptorTag = 0x75,
+               ContentIdentifierDescriptorTag = 0x76,
+               TimeSliceFecIdentifierDescriptorTag = 0x77,
+               ECMRepetitionRateDescriptorTag = 0x78,
+               S2SatelliteDeliverySystemDescriptorTag = 0x79,
+               EnhancedAC3DescriptorTag = 0x7A,
+               DTSDescriptorTag = 0x7B,
+               AACDescriptorTag = 0x7C,
+               ExtensionDescriptorTag = 0x7F,
+
  // Defined by ETSI TS 102 812 (MHP)
                // They once again start with 0x00 (see page 234, MHP specification)
                MHP_ApplicationDescriptorTag = 0x00,
diff -ruN vdr-1.5.0/menu.c vdr-1.5.1/menu.c
--- vdr-1.5.0/menu.c	2007-01-07 13:19:48.000000000 +0100
+++ vdr-1.5.1/menu.c	2007-02-25 15:04:33.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menu.c 1.447 2007/01/07 12:19:48 kls Exp $
+ * $Id: menu.c 1.450 2007/02/25 14:04:33 kls Exp $
  */
 
 #include "menu.h"
@@ -22,6 +22,7 @@
 #include "plugin.h"
 #include "recording.h"
 #include "remote.h"
+#include "shutdown.h"
 #include "sources.h"
 #include "status.h"
 #include "themes.h"
@@ -2206,7 +2207,7 @@
   Add(new cMenuEditBoolItem(tr("Setup.OSD$Timeout requested channel info"), &data.TimeoutRequChInfo));
   Add(new cMenuEditBoolItem(tr("Setup.OSD$Scroll pages"),           &data.MenuScrollPage));
   Add(new cMenuEditBoolItem(tr("Setup.OSD$Scroll wraps"),           &data.MenuScrollWrap));
-  Add(new cMenuEditBoolItem(tr("Setup.OSD$Menu button closes"),     &data.MenuButtonCloses));
+  Add(new cMenuEditBoolItem(tr("Setup.OSD$Menu key closes"),        &data.MenuKeyCloses));
   Add(new cMenuEditBoolItem(tr("Setup.OSD$Recording directories"),  &data.RecordingDirs));
   SetCurrent(Get(current));
   Display();
@@ -2661,6 +2662,7 @@
   Add(new cMenuEditIntItem( tr("Setup.Miscellaneous$Min. user inactivity (min)"), &data.MinUserInactivity));
   Add(new cMenuEditIntItem( tr("Setup.Miscellaneous$SVDRP timeout (s)"),          &data.SVDRPTimeout));
   Add(new cMenuEditIntItem( tr("Setup.Miscellaneous$Zap timeout (s)"),            &data.ZapTimeout));
+  Add(new cMenuEditIntItem( tr("Setup.Miscellaneous$Channel entry timeout (ms)"), &data.ChannelEntryTimeout, 0));
   Add(new cMenuEditChanItem(tr("Setup.Miscellaneous$Initial channel"),            &data.InitialChannel, tr("Setup.Miscellaneous$as before")));
   Add(new cMenuEditIntItem( tr("Setup.Miscellaneous$Initial volume"),             &data.InitialVolume, -1, 255, tr("Setup.Miscellaneous$as before")));
 }
@@ -2770,10 +2772,8 @@
 
 eOSState cMenuSetup::Restart(void)
 {
-  if (Interface->Confirm(tr("Really restart?"))
-     && (!cRecordControls::Active() || Interface->Confirm(tr("Recording - restart anyway?")))
-     && !cPluginManager::Active(tr("restart anyway?"))) {
-     cThread::EmergencyExit(true);
+  if (Interface->Confirm(tr("Really restart?")) && ShutdownHandler.ConfirmRestart(true)) {
+     ShutdownHandler.Exit(1);
      return osEnd;
      }
   return osContinue;
@@ -3090,8 +3090,6 @@
 
 // --- cDisplayChannel -------------------------------------------------------
 
-#define DIRECTCHANNELTIMEOUT 1000 //ms
-
 cDisplayChannel *cDisplayChannel::currentDisplayChannel = NULL;
 
 cDisplayChannel::cDisplayChannel(int Number, bool Switched)
@@ -3290,7 +3288,7 @@
          Refresh();
          break;
     case kNone:
-         if (number && lastTime.Elapsed() > DIRECTCHANNELTIMEOUT) {
+         if (number && Setup.ChannelEntryTimeout && int(lastTime.Elapsed()) > Setup.ChannelEntryTimeout) {
             channel = Channels.GetByNumber(number);
             if (channel)
                NewChannel = channel;
@@ -3699,7 +3697,7 @@
      if (device) {
         dsyslog("switching device %d to channel %d", device->DeviceNumber() + 1, channel->Number());
         if (!device->SwitchChannel(channel, false)) {
-           cThread::EmergencyExit(true);
+           ShutdownHandler.RequestEmergencyExit();
            return false;
            }
         if (!Timer || Timer->Matches()) {
diff -ruN vdr-1.5.0/newplugin vdr-1.5.1/newplugin
--- vdr-1.5.0/newplugin	2006-09-09 14:38:35.000000000 +0200
+++ vdr-1.5.1/newplugin	2007-02-24 14:23:08.000000000 +0100
@@ -12,7 +12,7 @@
 # See the main source file 'vdr.c' for copyright information and
 # how to reach the author.
 #
-# $Id: newplugin 1.30 2006/09/09 12:38:35 kls Exp $
+# $Id: newplugin 1.31 2007/02/24 13:23:08 kls Exp $
 
 $PLUGIN_NAME = $ARGV[0] || die "Usage: newplugin <name>\n";
 
@@ -169,6 +169,7 @@
   virtual void Housekeeping(void);
   virtual void MainThreadHook(void);
   virtual cString Active(void);
+  virtual time_t WakeupTime(void);
   virtual const char *MainMenuEntry(void) { return MAINMENUENTRY; }
   virtual cOsdObject *MainMenuAction(void);
   virtual cMenuSetupPage *SetupMenu(void);
@@ -236,6 +237,12 @@
   return NULL;
 }
 
+time_t cPlugin${PLUGIN_CLASS}::WakeupTime(void)
+{
+  // Return custom wakeup time for shutdown script
+  return 0;
+}
+
 cOsdObject *cPlugin${PLUGIN_CLASS}::MainMenuAction(void)
 {
   // Perform the action when selected from the main VDR menu.
diff -ruN vdr-1.5.0/osd.c vdr-1.5.1/osd.c
--- vdr-1.5.0/osd.c	2006-02-26 15:31:31.000000000 +0100
+++ vdr-1.5.1/osd.c	2007-02-17 17:05:52.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: osd.c 1.67 2006/02/26 14:31:31 kls Exp $
+ * $Id: osd.c 1.68 2007/02/17 16:05:52 kls Exp $
  */
 
 #include "osd.h"
@@ -218,14 +218,17 @@
                  int w, h, n, c;
                  if (4 != sscanf(s, "%d %d %d %d", &w, &h, &n, &c)) {
                     esyslog("ERROR: faulty 'values' line in XPM file '%s'", FileName);
+                    isXpm = false;
                     break;
                     }
                  lines = h + n + 1;
                  Xpm = MALLOC(char *, lines);
+                 memset(Xpm, 0, lines * sizeof(char*));
                  }
               char *q = strchr(s, '"');
               if (!q) {
                  esyslog("ERROR: missing quotes in XPM file '%s'", FileName);
+                 isXpm = false;
                  break;
                  }
               *q = 0;
@@ -233,16 +236,21 @@
                  Xpm[index++] = strdup(s);
               else {
                  esyslog("ERROR: too many lines in XPM file '%s'", FileName);
+                 isXpm = false;
                  break;
                  }
               }
            }
-     if (index == lines)
-        Result = SetXpm(Xpm);
-     else
-        esyslog("ERROR: too few lines in XPM file '%s'", FileName);
-     for (int i = 0; i < index; i++)
-         free(Xpm[i]);
+     if (isXpm) {
+        if (index == lines)
+           Result = SetXpm(Xpm);
+        else
+           esyslog("ERROR: too few lines in XPM file '%s'", FileName);
+        }
+     if (Xpm) {
+        for (int i = 0; i < index; i++)
+            free(Xpm[i]);
+        }
      free(Xpm);
      fclose(f);
      }
diff -ruN vdr-1.5.0/plugin.c vdr-1.5.1/plugin.c
--- vdr-1.5.0/plugin.c	2006-10-14 11:49:16.000000000 +0200
+++ vdr-1.5.1/plugin.c	2007-02-24 14:44:23.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: plugin.c 1.24 2006/10/14 09:49:16 kls Exp $
+ * $Id: plugin.c 1.25 2007/02/24 13:44:23 kls Exp $
  */
 
 #include "plugin.h"
@@ -80,6 +80,11 @@
   return NULL;
 }
 
+time_t cPlugin::WakeupTime(void)
+{
+  return 0;
+}
+
 const char *cPlugin::MainMenuEntry(void)
 {
   return NULL;
@@ -403,6 +408,26 @@
   return false;
 }
 
+cPlugin *cPluginManager::GetNextWakeupPlugin(void)
+{
+  cPlugin *NextPlugin = NULL;
+  if (pluginManager) {
+     time_t Now = time(NULL);
+     time_t Next = 0;
+     for (cDll *dll = pluginManager->dlls.First(); dll; dll = pluginManager->dlls.Next(dll)) {
+         cPlugin *p = dll->Plugin();
+         if (p) {
+            time_t t = p->WakeupTime();
+            if (t > Now && (!Next || t < Next)) {
+               Next = t;
+               NextPlugin = p;
+               }
+            }
+         }
+     }
+  return NextPlugin;
+}
+
 bool cPluginManager::HasPlugins(void)
 {
   return pluginManager && pluginManager->dlls.Count();
diff -ruN vdr-1.5.0/plugin.h vdr-1.5.1/plugin.h
--- vdr-1.5.0/plugin.h	2006-04-17 11:18:16.000000000 +0200
+++ vdr-1.5.1/plugin.h	2007-02-24 14:45:28.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: plugin.h 1.13 2006/04/17 09:18:16 kls Exp $
+ * $Id: plugin.h 1.14 2007/02/24 13:45:28 kls Exp $
  */
 
 #ifndef __PLUGIN_H
@@ -41,6 +41,7 @@
   virtual void Housekeeping(void);
   virtual void MainThreadHook(void);
   virtual cString Active(void);
+  virtual time_t WakeupTime(void);
 
   virtual const char *MainMenuEntry(void);
   virtual cOsdObject *MainMenuAction(void);
@@ -93,6 +94,7 @@
   void Housekeeping(void);
   void MainThreadHook(void);
   static bool Active(const char *Prompt = NULL);
+  static cPlugin *GetNextWakeupPlugin(void);
   static bool HasPlugins(void);
   static cPlugin *GetPlugin(int Index);
   static cPlugin *GetPlugin(const char *Name);
diff -ruN vdr-1.5.0/recorder.c vdr-1.5.1/recorder.c
--- vdr-1.5.0/recorder.c	2007-01-05 11:43:09.000000000 +0100
+++ vdr-1.5.1/recorder.c	2007-02-24 17:36:24.000000000 +0100
@@ -4,13 +4,14 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recorder.c 1.18 2007/01/05 10:43:09 kls Exp $
+ * $Id: recorder.c 1.19 2007/02/24 16:36:24 kls Exp $
  */
 
 #include "recorder.h"
 #include <stdarg.h>
 #include <stdio.h>
 #include <unistd.h>
+#include "shutdown.h"
 
 #define RECORDERBUFSIZE  MEGABYTE(5)
 
@@ -117,7 +118,7 @@
            }
         else if (time(NULL) - t > MAXBROKENTIMEOUT) {
            esyslog("ERROR: video data stream broken");
-           cThread::EmergencyExit(true);
+           ShutdownHandler.RequestEmergencyExit();
            t = time(NULL);
            }
         }
diff -ruN vdr-1.5.0/remote.c vdr-1.5.1/remote.c
--- vdr-1.5.0/remote.c	2006-12-02 12:12:42.000000000 +0100
+++ vdr-1.5.1/remote.c	2007-02-24 14:23:12.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remote.c 1.55 2006/12/02 11:12:42 kls Exp $
+ * $Id: remote.c 1.56 2007/02/24 13:23:12 kls Exp $
  */
 
 #include "remote.h"
@@ -31,6 +31,7 @@
 cCondVar cRemote::keyPressed;
 const char *cRemote::keyMacroPlugin = NULL;
 const char *cRemote::callPlugin = NULL;
+time_t cRemote::lastActivity = 0;
 
 cRemote::cRemote(const char *Name)
 {
@@ -183,6 +184,7 @@
             out = 0;
          if ((k & k_Repeat) != 0)
             repeatTimeout.Set(REPEATTIMEOUT);
+         lastActivity = time(NULL);
          return k;
          }
       else if (!WaitMs || !keyPressed.TimedWait(mutex, WaitMs) && repeatTimeout.TimedOut())
diff -ruN vdr-1.5.0/remote.h vdr-1.5.1/remote.h
--- vdr-1.5.0/remote.h	2006-12-02 12:12:49.000000000 +0100
+++ vdr-1.5.1/remote.h	2007-02-24 16:53:00.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remote.h 1.38 2006/12/02 11:12:49 kls Exp $
+ * $Id: remote.h 1.39 2007/02/24 15:53:00 kls Exp $
  */
 
 #ifndef __REMOTE_H
@@ -28,6 +28,7 @@
   static char *unknownCode;
   static cMutex mutex;
   static cCondVar keyPressed;
+  static time_t lastActivity;
   static const char *keyMacroPlugin;
   static const char *callPlugin;
   char *name;
@@ -61,6 +62,8 @@
       ///< plugin name will be reset to NULL by this call.
   static bool HasKeys(void);
   static eKeys Get(int WaitMs = 1000, char **UnknownCode = NULL);
+  static time_t LastActivity(void) { return lastActivity; }
+      ///< Absolute time when last key was delivered by Get().
   };
 
 class cRemotes : public cList<cRemote> {};
diff -ruN vdr-1.5.0/remux.c vdr-1.5.1/remux.c
--- vdr-1.5.0/remux.c	2006-12-01 15:46:25.000000000 +0100
+++ vdr-1.5.1/remux.c	2007-02-24 17:36:10.000000000 +0100
@@ -11,13 +11,13 @@
  * The cRepacker family's code was originally written by Reinhard Nissl <rnissl@gmx.de>,
  * and adapted to the VDR coding style by Klaus.Schmidinger@cadsoft.de.
  *
- * $Id: remux.c 1.57 2006/12/01 14:46:25 kls Exp $
+ * $Id: remux.c 1.58 2007/02/24 16:36:10 kls Exp $
  */
 
 #include "remux.h"
 #include <stdlib.h>
 #include "channels.h"
-#include "thread.h"
+#include "shutdown.h"
 #include "tools.h"
 
 ePesHeader AnalyzePesHeader(const uchar *Data, int Count, int &PesPayloadOffset, bool *ContinuationHeader)
@@ -2011,7 +2011,7 @@
         esyslog("ERROR: no useful data seen within %d byte of video stream", skipped);
         skipped = -1;
         if (exitOnFailure)
-           cThread::EmergencyExit(true);
+           ShutdownHandler.RequestEmergencyExit();
         }
      else
         skipped += used;
@@ -2059,7 +2059,7 @@
                   if (pt < I_FRAME || B_FRAME < pt) {
                      esyslog("ERROR: unknown picture type '%d'", pt);
                      if (++numUPTerrors > MAXNUMUPTERRORS && exitOnFailure)
-                        cThread::EmergencyExit(true);
+                        ShutdownHandler.RequestEmergencyExit();
                      }
                   else if (!synced) {
                      if (pt == I_FRAME) {
